Generic Subscriber Update Protocol

The Generic Subscriber Update Protocol (GSUP) is an Osmocom-specific non-standard protocol replacing MAP as the protocol between MSC/VLR/SGSN and HLR in a 3GPP cellular communications network. More...

## Files

file | gsup.h
file | gsup.c

## Data Structures

struct | osmo_gsup_pdp_info
| parsed/decoded PDP context information More...
struct | osmo_gsup_message
| parsed/decoded GSUP protocol message More...

## Macros

#define | OSMO_GSUP_PORT 4222
#define | OSMO_GSUP_MAX_NUM_PDP_INFO 10 /* GSM 09.02 limits this to 50 */
| Maximum nubmer of PDP inside osmo_gsup_message. More...
#define | OSMO_GSUP_MAX_NUM_AUTH_INFO 5
| Maximum number of auth info inside osmo_gsup_message. More...
#define | OSMO_GSUP_MAX_MSISDN_LEN 9
| Maximum number of octets encoding MSISDN in BCD format. More...
#define | OSMO_GSUP_MAX_CALLED_PARTY_BCD_LEN 43 /* TS 24.008 10.5.4.7 */
#define | OSMO_GSUP_PDP_TYPE_SIZE 2
#define | OSMO_GSUP_IS_MSGT_REQUEST(msgt) (((msgt) & 0b00000011) == 0b00)
#define | OSMO_GSUP_IS_MSGT_ERROR(msgt) (((msgt) & 0b00000011) == 0b01)
#define | OSMO_GSUP_TO_MSGT_ERROR(msgt) (((msgt) & 0b11111100) | 0b01)

## Enumerations

enum

osmo_gsup_iei {
OSMO_GSUP_IMSI_IE = 0x01,
OSMO_GSUP_CAUSE_IE = 0x02,
OSMO_GSUP_AUTH_TUPLE_IE = 0x03,
OSMO_GSUP_PDP_INFO_COMPL_IE = 0x04,
OSMO_GSUP_PDP_INFO_IE = 0x05,
OSMO_GSUP_CANCEL_TYPE_IE = 0x06,
OSMO_GSUP_FREEZE_PTMSI_IE = 0x07,
OSMO_GSUP_MSISDN_IE = 0x08,
OSMO_GSUP_HLR_NUMBER_IE = 0x09,
OSMO_GSUP_PDP_CONTEXT_ID_IE = 0x10,
OSMO_GSUP_PDP_TYPE_IE = 0x11,
OSMO_GSUP_ACCESS_POINT_NAME_IE = 0x12,
OSMO_GSUP_PDP_QOS_IE = 0x13,
OSMO_GSUP_CHARG_CHAR_IE = 0x14,
OSMO_GSUP_RAND_IE = 0x20,
OSMO_GSUP_SRES_IE = 0x21,
OSMO_GSUP_KC_IE = 0x22,
OSMO_GSUP_IK_IE = 0x23,
OSMO_GSUP_CK_IE = 0x24,
OSMO_GSUP_AUTN_IE = 0x25,
OSMO_GSUP_AUTS_IE = 0x26,
OSMO_GSUP_RES_IE = 0x27,
OSMO_GSUP_CN_DOMAIN_IE = 0x28,
OSMO_GSUP_SESSION_ID_IE = 0x30,
OSMO_GSUP_SESSION_STATE_IE = 0x31,
OSMO_GSUP_SS_INFO_IE = 0x35
}

| Information Element Identifiers for GSUP IEs. More...

enum

osmo_gsup_message_type {
OSMO_GSUP_MSGT_UPDATE_LOCATION_REQUEST = 0b00000100,
OSMO_GSUP_MSGT_UPDATE_LOCATION_ERROR = 0b00000101,
OSMO_GSUP_MSGT_UPDATE_LOCATION_RESULT = 0b00000110,
OSMO_GSUP_MSGT_SEND_AUTH_INFO_REQUEST = 0b00001000,
OSMO_GSUP_MSGT_SEND_AUTH_INFO_ERROR = 0b00001001,
OSMO_GSUP_MSGT_SEND_AUTH_INFO_RESULT = 0b00001010,
OSMO_GSUP_MSGT_AUTH_FAIL_REPORT = 0b00001011,
OSMO_GSUP_MSGT_PURGE_MS_REQUEST = 0b00001100,
OSMO_GSUP_MSGT_PURGE_MS_ERROR = 0b00001101,
OSMO_GSUP_MSGT_PURGE_MS_RESULT = 0b00001110,
OSMO_GSUP_MSGT_INSERT_DATA_REQUEST = 0b00010000,
OSMO_GSUP_MSGT_INSERT_DATA_ERROR = 0b00010001,
OSMO_GSUP_MSGT_INSERT_DATA_RESULT = 0b00010010,
OSMO_GSUP_MSGT_DELETE_DATA_REQUEST = 0b00010100,
OSMO_GSUP_MSGT_DELETE_DATA_ERROR = 0b00010101,
OSMO_GSUP_MSGT_DELETE_DATA_RESULT = 0b00010110,
OSMO_GSUP_MSGT_LOCATION_CANCEL_REQUEST = 0b00011100,
OSMO_GSUP_MSGT_LOCATION_CANCEL_ERROR = 0b00011101,
OSMO_GSUP_MSGT_LOCATION_CANCEL_RESULT = 0b00011110,
OSMO_GSUP_MSGT_PROC_SS_REQUEST = 0b00100000,
OSMO_GSUP_MSGT_PROC_SS_ERROR = 0b00100001,
OSMO_GSUP_MSGT_PROC_SS_RESULT = 0b00100010
}

| GSUP message type. More...
enum | osmo_gsup_cancel_type { OSMO_GSUP_CANCEL_TYPE_UPDATE = 1, OSMO_GSUP_CANCEL_TYPE_WITHDRAW = 2 }
enum | osmo_gsup_cn_domain { OSMO_GSUP_CN_DOMAIN_PS = 1, OSMO_GSUP_CN_DOMAIN_CS = 2 }
enum | osmo_gsup_session_state { OSMO_GSUP_SESSION_STATE_NONE = 0x00, OSMO_GSUP_SESSION_STATE_BEGIN = 0x01, OSMO_GSUP_SESSION_STATE_CONTINUE = 0x02, OSMO_GSUP_SESSION_STATE_END = 0x03 }
| TCAP-like session state. More...

## Functions

static const char * | osmo_gsup_message_type_name (enum osmo_gsup_message_type val)
static const char * | osmo_gsup_session_state_name (enum osmo_gsup_session_state val)
int | osmo_gsup_decode (const uint8_t *const_data, size_t data_len, struct osmo_gsup_message *gsup_msg)
| Decode (parse) a GSUP message. More...
int | osmo_gsup_encode (struct msgb *msg, const struct osmo_gsup_message *gsup_msg)
| Encode a GSUP message. More...
int | osmo_gsup_get_err_msg_type (enum osmo_gsup_message_type type_in)
| return the error message type corresponding to type_in More...
static int | decode_pdp_info (uint8_t *data, size_t data_len, struct osmo_gsup_pdp_info *pdp_info)
static int | decode_auth_info (uint8_t *data, size_t data_len, struct osmo_auth_vector *auth_vector)
static void | encode_pdp_info (struct msgb *msg, enum osmo_gsup_iei iei, const struct osmo_gsup_pdp_info *pdp_info)
static void | encode_auth_info (struct msgb *msg, enum osmo_gsup_iei iei, const struct osmo_auth_vector *auth_vector)

## Variables

const struct value_string | osmo_gsup_message_type_names []
const struct value_string | osmo_gsup_session_state_names []
const struct value_string | osmo_gsup_message_type_names []
const struct value_string | osmo_gsup_session_state_names []

## Detailed Description

The Generic Subscriber Update Protocol (GSUP) is an Osmocom-specific non-standard protocol replacing MAP as the protocol between MSC/VLR/SGSN and HLR in a 3GPP cellular communications network.

It was designed around the same transactions and architecture as the MAP messages/operations, but without the complexity of TCAP and MAP, and without the need for ASN.1 encoding.

The purpose is to keep protocol complexity out of OsmoSGSN and OsmoMSC, while providing a clean path to an external GSUP to MAP translator.

## Macro Definition Documentation

## OSMO_GSUP_IS_MSGT_ERROR

#define OSMO_GSUP_IS_MSGT_ERROR | ( |  | msgt | ) | (((msgt) & 0b00000011) == 0b01)

## OSMO_GSUP_IS_MSGT_REQUEST

#define OSMO_GSUP_IS_MSGT_REQUEST | ( |  | msgt | ) | (((msgt) & 0b00000011) == 0b00)

## OSMO_GSUP_MAX_CALLED_PARTY_BCD_LEN

#define OSMO_GSUP_MAX_CALLED_PARTY_BCD_LEN 43 /* TS 24.008 10.5.4.7 */

## OSMO_GSUP_MAX_MSISDN_LEN

#define OSMO_GSUP_MAX_MSISDN_LEN 9

Maximum number of octets encoding MSISDN in BCD format.

## OSMO_GSUP_MAX_NUM_AUTH_INFO

#define OSMO_GSUP_MAX_NUM_AUTH_INFO 5

Maximum number of auth info inside osmo_gsup_message.

## OSMO_GSUP_MAX_NUM_PDP_INFO

#define OSMO_GSUP_MAX_NUM_PDP_INFO 10 /* GSM 09.02 limits this to 50 */

Maximum nubmer of PDP inside osmo_gsup_message.

## OSMO_GSUP_PDP_TYPE_SIZE

#define OSMO_GSUP_PDP_TYPE_SIZE 2

## OSMO_GSUP_PORT

#define OSMO_GSUP_PORT 4222

## OSMO_GSUP_TO_MSGT_ERROR

#define OSMO_GSUP_TO_MSGT_ERROR | ( |  | msgt | ) | (((msgt) & 0b11111100) | 0b01)

## Enumeration Type Documentation

## osmo_gsup_cancel_type

enum osmo_gsup_cancel_type

Enumerator
OSMO_GSUP_CANCEL_TYPE_UPDATE |
OSMO_GSUP_CANCEL_TYPE_WITHDRAW |

## osmo_gsup_cn_domain

enum osmo_gsup_cn_domain

Enumerator
OSMO_GSUP_CN_DOMAIN_PS |
OSMO_GSUP_CN_DOMAIN_CS |

## osmo_gsup_iei

enum osmo_gsup_iei

Information Element Identifiers for GSUP IEs.

Enumerator
OSMO_GSUP_IMSI_IE |
OSMO_GSUP_CAUSE_IE |
OSMO_GSUP_AUTH_TUPLE_IE |
OSMO_GSUP_PDP_INFO_COMPL_IE |
OSMO_GSUP_PDP_INFO_IE |
OSMO_GSUP_CANCEL_TYPE_IE |
OSMO_GSUP_FREEZE_PTMSI_IE |
OSMO_GSUP_MSISDN_IE |
OSMO_GSUP_HLR_NUMBER_IE |
OSMO_GSUP_PDP_CONTEXT_ID_IE |
OSMO_GSUP_PDP_TYPE_IE |
OSMO_GSUP_ACCESS_POINT_NAME_IE |
OSMO_GSUP_PDP_QOS_IE |
OSMO_GSUP_CHARG_CHAR_IE |
OSMO_GSUP_RAND_IE |
OSMO_GSUP_SRES_IE |
OSMO_GSUP_KC_IE |
OSMO_GSUP_IK_IE |
OSMO_GSUP_CK_IE |
OSMO_GSUP_AUTN_IE |
OSMO_GSUP_AUTS_IE |
OSMO_GSUP_RES_IE |
OSMO_GSUP_CN_DOMAIN_IE |
OSMO_GSUP_SESSION_ID_IE |
OSMO_GSUP_SESSION_STATE_IE |
OSMO_GSUP_SS_INFO_IE | Supplementary Services payload.

## osmo_gsup_message_type

enum osmo_gsup_message_type

GSUP message type.

Enumerator
OSMO_GSUP_MSGT_UPDATE_LOCATION_REQUEST |
OSMO_GSUP_MSGT_UPDATE_LOCATION_ERROR |
OSMO_GSUP_MSGT_UPDATE_LOCATION_RESULT |
OSMO_GSUP_MSGT_SEND_AUTH_INFO_REQUEST |
OSMO_GSUP_MSGT_SEND_AUTH_INFO_ERROR |
OSMO_GSUP_MSGT_SEND_AUTH_INFO_RESULT |
OSMO_GSUP_MSGT_AUTH_FAIL_REPORT |
OSMO_GSUP_MSGT_PURGE_MS_REQUEST |
OSMO_GSUP_MSGT_PURGE_MS_ERROR |
OSMO_GSUP_MSGT_PURGE_MS_RESULT |
OSMO_GSUP_MSGT_INSERT_DATA_REQUEST |
OSMO_GSUP_MSGT_INSERT_DATA_ERROR |
OSMO_GSUP_MSGT_INSERT_DATA_RESULT |
OSMO_GSUP_MSGT_DELETE_DATA_REQUEST |
OSMO_GSUP_MSGT_DELETE_DATA_ERROR |
OSMO_GSUP_MSGT_DELETE_DATA_RESULT |
OSMO_GSUP_MSGT_LOCATION_CANCEL_REQUEST |
OSMO_GSUP_MSGT_LOCATION_CANCEL_ERROR |
OSMO_GSUP_MSGT_LOCATION_CANCEL_RESULT |
OSMO_GSUP_MSGT_PROC_SS_REQUEST |
OSMO_GSUP_MSGT_PROC_SS_ERROR |
OSMO_GSUP_MSGT_PROC_SS_RESULT |

## osmo_gsup_session_state

enum osmo_gsup_session_state

TCAP-like session state.

Enumerator
OSMO_GSUP_SESSION_STATE_NONE | Undefined session state.
OSMO_GSUP_SESSION_STATE_BEGIN | Initiation of a new session.
OSMO_GSUP_SESSION_STATE_CONTINUE | Communication of an existing session.
OSMO_GSUP_SESSION_STATE_END | Indication of the session end.

## Function Documentation

## decode_auth_info()

static int decode_auth_info | ( | uint8_t * | data,
|  | size_t | data_len,
|  | struct osmo_auth_vector * | auth_vector
| ) |  |

static

References osmo_auth_vector::auth_types, osmo_auth_vector::autn, osmo_auth_vector::ck, data, GMM_CAUSE_PROTO_ERR_UNSPEC, iei, osmo_auth_vector::ik, osmo_auth_vector::kc, OSMO_AUTH_TYPE_GSM, OSMO_AUTH_TYPE_UMTS, OSMO_GSUP_AUTN_IE, OSMO_GSUP_CK_IE, OSMO_GSUP_IK_IE, OSMO_GSUP_KC_IE, OSMO_GSUP_RAND_IE, OSMO_GSUP_RES_IE, OSMO_GSUP_SRES_IE, osmo_shift_tlv(), osmo_auth_vector::rand, osmo_auth_vector::res, osmo_auth_vector::res_len, and osmo_auth_vector::sres.

Referenced by osmo_gsup_decode().

## decode_pdp_info()

static int decode_pdp_info | ( | uint8_t * | data,
|  | size_t | data_len,
|  | struct osmo_gsup_pdp_info * | pdp_info
| ) |  |

static

References osmo_gsup_pdp_info::apn_enc, osmo_gsup_pdp_info::apn_enc_len, osmo_gsup_pdp_info::context_id, data, GMM_CAUSE_PROTO_ERR_UNSPEC, iei, OSMO_GSUP_ACCESS_POINT_NAME_IE, OSMO_GSUP_CHARG_CHAR_IE, OSMO_GSUP_PDP_CONTEXT_ID_IE, OSMO_GSUP_PDP_QOS_IE, OSMO_GSUP_PDP_TYPE_IE, osmo_shift_tlv(), osmo_gsup_pdp_info::pdp_charg_enc, osmo_gsup_pdp_info::pdp_charg_enc_len, osmo_gsup_pdp_info::pdp_type, osmo_gsup_pdp_info::qos_enc, and osmo_gsup_pdp_info::qos_enc_len.

Referenced by osmo_gsup_decode().

## encode_auth_info()

static void encode_auth_info | ( | struct msgb * | msg,
|  | enum osmo_gsup_iei | iei,
|  | const struct osmo_auth_vector * | auth_vector
| ) |  |

static

References osmo_auth_vector::auth_types, osmo_auth_vector::autn, osmo_auth_vector::ck, iei, osmo_auth_vector::ik, osmo_auth_vector::kc, msgb_tlv_put(), OSMO_AUTH_TYPE_GSM, OSMO_AUTH_TYPE_UMTS, OSMO_GSUP_AUTN_IE, OSMO_GSUP_CK_IE, OSMO_GSUP_IK_IE, OSMO_GSUP_KC_IE, OSMO_GSUP_RAND_IE, OSMO_GSUP_RES_IE, OSMO_GSUP_SRES_IE, osmo_auth_vector::rand, osmo_auth_vector::res, osmo_auth_vector::res_len, and osmo_auth_vector::sres.

Referenced by osmo_gsup_encode().

## encode_pdp_info()

static void encode_pdp_info | ( | struct msgb * | msg,
|  | enum osmo_gsup_iei | iei,
|  | const struct osmo_gsup_pdp_info * | pdp_info
| ) |  |

static

References osmo_gsup_pdp_info::apn_enc, osmo_gsup_pdp_info::apn_enc_len, osmo_gsup_pdp_info::context_id, iei, msgb_tlv_put(), OSMO_GSUP_ACCESS_POINT_NAME_IE, OSMO_GSUP_CHARG_CHAR_IE, OSMO_GSUP_PDP_CONTEXT_ID_IE, OSMO_GSUP_PDP_QOS_IE, OSMO_GSUP_PDP_TYPE_IE, OSMO_GSUP_PDP_TYPE_SIZE, osmo_gsup_pdp_info::pdp_charg_enc, osmo_gsup_pdp_info::pdp_charg_enc_len, osmo_gsup_pdp_info::pdp_type, osmo_gsup_pdp_info::qos_enc, and osmo_gsup_pdp_info::qos_enc_len.

Referenced by osmo_gsup_encode().

## osmo_gsup_decode()

int osmo_gsup_decode | ( | const uint8_t * | const_data,
|  | size_t | data_len,
|  | struct osmo_gsup_message * | gsup_msg
| ) |  |

Decode (parse) a GSUP message.

Parameters

  [in] | const_data | input data to be parsed
  [in] | data_len | length of input (const_data)
  [out] | gsup_msg | callee-allocated output data structure

Returns
  0 on success; negative otherwise

References osmo_gsup_message::auth_vectors, osmo_gsup_message::auts, osmo_gsup_message::cancel_type, osmo_gsup_message::cause, osmo_gsup_message::cn_domain, osmo_gsup_pdp_info::context_id, data, decode_auth_info(), decode_pdp_info(), osmo_gsup_message::freeze_ptmsi, GMM_CAUSE_COND_IE_ERR, GMM_CAUSE_INV_MAND_INFO, GMM_CAUSE_PROTO_ERR_UNSPEC, gsm48_decode_bcd_number(), osmo_gsup_pdp_info::have_info, osmo_gsup_message::hlr_enc, osmo_gsup_message::hlr_enc_len, iei, osmo_gsup_message::imsi, osmo_gsup_message::message_type, osmo_gsup_message::msisdn_enc, osmo_gsup_message::msisdn_enc_len, osmo_gsup_message::num_auth_vectors, osmo_gsup_message::num_pdp_infos, OSMO_GSUP_ACCESS_POINT_NAME_IE, OSMO_GSUP_AUTH_TUPLE_IE, OSMO_GSUP_AUTS_IE, OSMO_GSUP_CANCEL_TYPE_IE, OSMO_GSUP_CAUSE_IE, OSMO_GSUP_CHARG_CHAR_IE, OSMO_GSUP_CN_DOMAIN_IE, OSMO_GSUP_FREEZE_PTMSI_IE, OSMO_GSUP_HLR_NUMBER_IE, OSMO_GSUP_IMSI_IE, OSMO_GSUP_KC_IE, OSMO_GSUP_MAX_NUM_AUTH_INFO, OSMO_GSUP_MAX_NUM_PDP_INFO, OSMO_GSUP_MSISDN_IE, OSMO_GSUP_PDP_CONTEXT_ID_IE, OSMO_GSUP_PDP_INFO_COMPL_IE, OSMO_GSUP_PDP_INFO_IE, OSMO_GSUP_PDP_TYPE_IE, OSMO_GSUP_RAND_IE, OSMO_GSUP_SESSION_ID_IE, OSMO_GSUP_SESSION_STATE_IE, OSMO_GSUP_SRES_IE, OSMO_GSUP_SS_INFO_IE, osmo_match_shift_tlv(), osmo_shift_tlv(), osmo_shift_v_fixed(), osmo_gsup_message::pdp_charg_enc, osmo_gsup_message::pdp_charg_enc_len, osmo_gsup_message::pdp_info_compl, osmo_gsup_message::pdp_infos, osmo_gsup_message::rand, osmo_gsup_message::session_id, osmo_gsup_message::session_state, osmo_gsup_message::ss_info, and osmo_gsup_message::ss_info_len.

## osmo_gsup_encode()

int osmo_gsup_encode | ( | struct msgb * | msg,
|  | const struct osmo_gsup_message * | gsup_msg
| ) |  |

Encode a GSUP message.

Parameters

  [out] | msg | message buffer to which encoded message is written
  [in] | gsup_msg | osmo_gsup_message data to be encoded

Returns
  0 on success; negative otherwise

References osmo_gsup_message::auth_vectors, osmo_gsup_message::auts, osmo_gsup_message::cancel_type, osmo_gsup_message::cause, osmo_gsup_message::cn_domain, osmo_gsup_pdp_info::context_id, encode_auth_info(), encode_pdp_info(), osmo_gsup_message::freeze_ptmsi, gsm48_encode_bcd_number(), GSM48_MI_SIZE, osmo_gsup_pdp_info::have_info, osmo_gsup_message::hlr_enc, osmo_gsup_message::hlr_enc_len, osmo_gsup_message::imsi, len, osmo_gsup_message::message_type, msgb_tlv_put(), msgb_v_put(), osmo_gsup_message::msisdn_enc, osmo_gsup_message::msisdn_enc_len, osmo_gsup_message::num_auth_vectors, osmo_gsup_message::num_pdp_infos, OSMO_GSUP_AUTH_TUPLE_IE, OSMO_GSUP_AUTS_IE, OSMO_GSUP_CANCEL_TYPE_IE, OSMO_GSUP_CAUSE_IE, OSMO_GSUP_CHARG_CHAR_IE, OSMO_GSUP_CN_DOMAIN_IE, OSMO_GSUP_FREEZE_PTMSI_IE, OSMO_GSUP_HLR_NUMBER_IE, OSMO_GSUP_IMSI_IE, OSMO_GSUP_MSISDN_IE, OSMO_GSUP_PDP_CONTEXT_ID_IE, OSMO_GSUP_PDP_INFO_COMPL_IE, OSMO_GSUP_PDP_INFO_IE, OSMO_GSUP_RAND_IE, OSMO_GSUP_SESSION_ID_IE, OSMO_GSUP_SESSION_STATE_IE, OSMO_GSUP_SS_INFO_IE, osmo_gsup_message::pdp_charg_enc, osmo_gsup_message::pdp_charg_enc_len, osmo_gsup_message::pdp_info_compl, osmo_gsup_message::pdp_infos, osmo_gsup_message::rand, osmo_gsup_message::session_id, osmo_gsup_message::session_state, osmo_gsup_message::ss_info, and osmo_gsup_message::ss_info_len.

## osmo_gsup_get_err_msg_type()

int osmo_gsup_get_err_msg_type | ( | enum osmo_gsup_message_type | type_in | ) |

return the error message type corresponding to type_in

Returns
  matching error message type; -1 on error

References OSMO_GSUP_MSGT_DELETE_DATA_ERROR, OSMO_GSUP_MSGT_DELETE_DATA_REQUEST, OSMO_GSUP_MSGT_INSERT_DATA_ERROR, OSMO_GSUP_MSGT_INSERT_DATA_REQUEST, OSMO_GSUP_MSGT_LOCATION_CANCEL_ERROR, OSMO_GSUP_MSGT_LOCATION_CANCEL_REQUEST, OSMO_GSUP_MSGT_PURGE_MS_ERROR, OSMO_GSUP_MSGT_PURGE_MS_REQUEST, OSMO_GSUP_MSGT_SEND_AUTH_INFO_ERROR, OSMO_GSUP_MSGT_SEND_AUTH_INFO_REQUEST, OSMO_GSUP_MSGT_UPDATE_LOCATION_ERROR, and OSMO_GSUP_MSGT_UPDATE_LOCATION_REQUEST.

## osmo_gsup_message_type_name()

static const char* osmo_gsup_message_type_name | ( | enum osmo_gsup_message_type | val | ) |

inline static

References osmo_gsup_message_type_names.

## osmo_gsup_session_state_name()

static const char* osmo_gsup_session_state_name | ( | enum osmo_gsup_session_state | val | ) |

inline static

References osmo_gsup_session_state_names.

## Variable Documentation

## osmo_gsup_message_type_names [1/2]

const struct value_string osmo_gsup_message_type_names[]

Referenced by osmo_gsup_message_type_name().

## osmo_gsup_message_type_names [2/2]

const struct value_string osmo_gsup_message_type_names[]

Referenced by osmo_gsup_message_type_name().

## osmo_gsup_session_state_names [1/2]

const struct value_string osmo_gsup_session_state_names[]

Initial value:
= {
{ OSMO_GSUP_SESSION_STATE_NONE, "NONE" },
{ OSMO_GSUP_SESSION_STATE_BEGIN, "BEGIN" },
{ OSMO_GSUP_SESSION_STATE_CONTINUE, "CONTINUE" },
{ OSMO_GSUP_SESSION_STATE_END, "END" },
{ 0, NULL }
}

Referenced by osmo_gsup_session_state_name().

## osmo_gsup_session_state_names [2/2]

const struct value_string osmo_gsup_session_state_names[]

Referenced by osmo_gsup_session_state_name().

OSMO_GSUP_SESSION_STATE_NONE
@ OSMO_GSUP_SESSION_STATE_NONE
Undefined session state.
Definition: gsup.h:148
OSMO_GSUP_SESSION_STATE_BEGIN
@ OSMO_GSUP_SESSION_STATE_BEGIN
Initiation of a new session.
Definition: gsup.h:150
OSMO_GSUP_SESSION_STATE_END
@ OSMO_GSUP_SESSION_STATE_END
Indication of the session end.
Definition: gsup.h:154
OSMO_GSUP_SESSION_STATE_CONTINUE
@ OSMO_GSUP_SESSION_STATE_CONTINUE
Communication of an existing session.
Definition: gsup.h:152